package cz.muni.fi.pb162.junit;

import java.util.Calendar;
import java.util.Date;

public class PersonWithNoError {
    
    private Date birthdate;
    private String name;
    
    public PersonWithNoError(Date birthDate, String name) {
	this.birthdate = birthDate;
	this.name = name;
    }

    public Date getBirthdate() {
        return birthdate;
    }

    public String getName() {
        return name;
    }

    public int getAge(Date when) {
	Calendar birthdateCalendar = Calendar.getInstance();
	Calendar whenCalendar = Calendar.getInstance();
	birthdateCalendar.setTime(birthdate);
	birthdateCalendar.set(Calendar.MILLISECOND,1);
	birthdateCalendar.set(Calendar.SECOND,0);
	birthdateCalendar.set(Calendar.MINUTE,0);
	birthdateCalendar.set(Calendar.HOUR_OF_DAY,0);
	whenCalendar.setTime(when);
	
	int result = whenCalendar.get(Calendar.YEAR) - 
		birthdateCalendar.get(Calendar.YEAR);
	whenCalendar.add(Calendar.YEAR,-result);
	if (whenCalendar.before(birthdateCalendar)) {
	    result--;
	}
	return result;
    }
    
    public boolean equals(Object obj) {
	return (obj instanceof PersonWithNoError) && 
	    ((PersonWithNoError) obj).getBirthdate().equals(getBirthdate()) &&
	    ((PersonWithNoError) obj).getName().equals(getName());
    }
    
    public int hashCode() {
	int result = 17;
	result = 37*result + getBirthdate().hashCode();
	result = 37*result + getName().hashCode();
	return result;
    }
    
    public static String getDescription() {
	return "trida neobsahuje zadnou chybu a testy by mely probehnout bez problemu";
    }
}
