package cz.muni.fi.pb162.junit;

import java.util.Calendar;
import java.util.Date;

public class PersonWrongGetAge2 extends PersonWithNoError {
    
    public PersonWrongGetAge2(Date birthDate, String name) {
	super(birthDate, name);
    }
    
    public static String getDescription() {
	return "trida obsahuje chybu v metode getAge (ke zmene veku dojde " +
		"o milisekundu drive, tj. o pulnoci je jiz clovek starsi)";
    }
    
    public int getAge(Date when) {
	Calendar birthdateCalendar = Calendar.getInstance();
	Calendar whenCalendar = Calendar.getInstance();
	birthdateCalendar.setTime(getBirthdate());
	birthdateCalendar.set(Calendar.MILLISECOND,0);
	birthdateCalendar.set(Calendar.SECOND,0);
	birthdateCalendar.set(Calendar.MINUTE,0);
	birthdateCalendar.set(Calendar.HOUR_OF_DAY,0);
	whenCalendar.setTime(when);
	
	int result = whenCalendar.get(Calendar.YEAR) -
		birthdateCalendar.get(Calendar.YEAR);
	whenCalendar.add(Calendar.YEAR,-result);
	if (whenCalendar.before(birthdateCalendar)) {
	    result--;
	}
	return result;
    }
}
